10  'GWWORM.BAS ------------------------ R.AUKERMAN --- OCTOBER 1990 --
11  '
20  'AN EXAMPLE OF BLOADing GRAPHIC IMAGES INTO ARRAYS AND THEN SIMPLY
30  'PUTing THEM ON THE SCREEN IN AN INCREMENTED LOOP AS AN ANIMATION.
40  'PAGE FLIPPING IS USED TO HIDE OBJECT RE-PAINTING AND THE ASSOCIATED
50  '"RIPPLE". GWWORM.BAS WAS WRITTEN TO RUN INSIDE WGBASIC 3.2 OR LATER;
51  'WITH EGA OR VGA ADAPTER AND COLOR MONITOR.   IT IS NOT INTENDED TO
52  'BE COMPILED.   IN INTERPRETER BASIC THE ANIMATION IS A LITTLE SLOW.
55  'ELEVEN BSAVED GRAPHICS ARE LOADED IN THE PROGRAM.  THESE .BAX FILES
56  'MUST BE IN THE CURRENT DIRECTORY WITH THE PROGRAM WHEN RUNNING.
57  'EVENT TRAPS GIVE SPEED CONTROL VIA Left/Right CURSOR KEYS.
58  'This program was also written in QuickBASIC. Look for QBWORM.BAS.
59  'And WORM.EXE which is the compiled stand alone version; Much faster.
60  '-------------------------------------------------------------------
62  'BLOADable IMAGES WERE PREPARED WITH THE BSAVER PROGRAM by ONEWORD.
63  '-------------------------------------------------------------------
64  '
65  ' ---------- INITIALIZE CONSTANTS, SCREEN, KEY traps --------------
70  DEFINT A-Z
80   G = 1              'For Page-Flip algorithm
85   Q = 1              'Q value sets speed at outset; 1 is fastest
90   CLS: KEY OFF
100  SCREEN 9,,1,1:  CLS   'BASIC SCREEN 9 and Page 1 visual and active
110  ON KEY(12) GOSUB 990
120  ON KEY(13) GOSUB 1030
130  KEY 16,CHR$(&H20)+CHR$(&H1)
140  ON KEY(16) GOSUB 1070
150  KEY 15,CHR$(&H0)+ CHR$(&H1)
160  ON KEY(15) GOSUB 1070
165 ' -------- BLOAD AND PUT A DIVERSION GRAPHIC ASAP -----------------
170  DEF SEG
180  DIM LOADING(1000)
190      VL$ = "LOADING.BAX"
200       BLOAD VL$, VARPTR(LOADING(0))
210  PUT (260,150), LOADING, PSET
215 ' -----DIM ARRAYs AND BLOAD GRAPHICS INTO BASIC'S WORK SPACE ----
220  DIM AWORM(1450)
230  DIM BWORM(1450)
235  DIM B2WORM(1450)
240  DIM CWORM(1450)
260  DIM DWORM(1450)
265  DIM BLACK(1450)
270  DIM SPEED(1168)
280  DIM CALW(3430)
285  DIM RULE(1650)
286  DIM ESK(442)
287  DIM OWORD(590)
300     VA$ = "AWORM.BAX"
310      BLOAD VA$, VARPTR(AWORM(0))
320     VB$ = "BWORM.BAX"
324      BLOAD VB$, VARPTR(BWORM(0))
325     VB2$ = "B2WORM.BAX"
327      BLOAD VB2$, VARPTR(B2WORM(0))
340     VC$ = "CWORM.BAX"
350      BLOAD VC$, VARPTR(CWORM(0))
360     VD$ = "DWORM.BAX"
370      BLOAD VD$, VARPTR(DWORM(0))
380     VS$ = "SPEED.BAX"
390      BLOAD VS$, VARPTR(SPEED(0))
400     VW$ = "CALWORM.BAX"
410      BLOAD VW$, VARPTR(CALW(0))
411     VR$ = "RULE.BAX"
412      BLOAD VR$, VARPTR(RULE(0))
415     VE$ = "ESK.BAX"
416      BLOAD VE$, VARPTR(ESK(0))
417     VO$ = "OWORD.BAX"
418      BLOAD VO$, VARPTR(OWORD(0))
420  GET (0 , 0) - (106, 36), BLACK     ' A COVER PATCH OF BACKGROUND
430  CLS
432 ' ----- DRAW LINES AND PUT GRAPHICS ON ACTIVE (HIDDEN) PAGE --------
435  SCREEN ,,0,1               'Page 1 still visual but 0 is now active
440  LINE (21, 216) - (603, 216),7
442  LINE (602, 218) - (602, 280),6
443  LINE (601,261) - (601, 281),6
444  LINE (600,261) - (600, 281),6
445  LINE (22, 218) - (602, 218),14
447  LINE (21, 219) - (21, 280),6
448  LINE (22, 261) - (22, 281),6
449  LINE (23, 261) - (23, 281),6
450  PUT (60,120), CALW, PSET
460  PUT (360,300),SPEED, PSET
461  FOR R = 24 TO 504 STEP 96
462   PUT (R,220), RULE,  PSET
463  NEXT R
464  PUT (363,323), ESK, PSET
465  PUT (60,300), OWORD, PSET
470  PCOPY 0,1                 'Copy all of Page 0 to Page1
480  KEY(12) ON: KEY(13) ON: KEY (15) ON: KEY (16) ON
485 ' ----- MAKE PAGE 0 VISUAL, PAGE 1 IS ACTIVE (BUT OUT OF VIEW) ------
490  SCREEN ,,1,0
495 ' ----- START RECYCLE LOOP.   20 PASSES COULD BE ANYNUMBER. ---------
496 ' ----- GOSUB FOR TIME DELAY INFO.
497 ' -----   -------------------------------------
500  FOR S = 1 TO 20 STEP 1
595 ' ---- START ANIMATION LOOPS.  PUT 5 WORM CELS AND SOME COVER PATCHES
596 ' ---- GOSUB FOR TIME DELAY INFO.  PAGES FLIP 1-0-1-0 USING THE ----
597 ' ----- SCREEN ALGORITHM.                                ------------
600  FOR X = 20 TO 476 STEP 24
612    PUT(X,179), AWORM, PSET
613  SCREEN ,,1-G,G
614  GOSUB 940
616  G = 1-G
620    PUT(X, 179), BWORM, PSET
640  SCREEN ,,1-G,G
660  GOSUB 940
670  G = 1-G
690    PUT(X,179), B2WORM, PSET
700  SCREEN ,,1-G,G
710  GOSUB 940
720  G = 1-G
730    PUT(X,179),CWORM,PSET
750  SCREEN ,,1-G,G
760  GOSUB 940
770  G = 1-G
790    PUT(X+7,179), B2WORM, PSET
800  SCREEN ,,1-G,G
805  GOSUB 940
810  G = 1-G
811  PUT(X,179), BLACK, PSET
812  PUT(X+24,179), DWORM, PSET
814  SCREEN ,,1-G,G
816  GOSUB 940
818  G = 1-G
820  NEXT X
821 ' -- PAUSE AND CLEAN UP AT THE END OF THE WALK, THEN LOOP -----
822  PUT (500,179), AWORM,PSET
824  SCREEN ,,1-G,G
825  GOSUB 940: GOSUB 940: GOSUB 940
828  G = 1-G
830  FOR B = 1 TO 2
840   PUT(500,179), BLACK, PSET
880   SCREEN ,, 1-G,G: G = 1-G   ' FLIP AND CLEAN THE OTHER PAGE --
890  NEXT B
900  NEXT
910 GOSUB 1070                   ' TIDY UP THE SHUT DOWN
930 '
935 '-- TIME DELAY SUB AND KEY TRAP CHANGING THE LOOP COUNTER, Q ---
940 FOR R = 1 TO Q^2       'TIME DELAY; SEE SLOWDOWN/SPEEDUP SUBS
950 LINE(5,10)-(635,10),0  'TRIM TIME WITH LINE LENGTH (workload)
960 NEXT                   'INITIALIZE Q TO START AT A "DESIRED"
970 RETURN                 'DELAY TIME.
980 '
990  Q = Q+1                 'SLOWDOWN SUB
1000 IF Q => 64 THEN Q=64
1010 RETURN
1020 '
1030 Q = Q-1                 'SPEEDUP SUB
1040 IF Q <= 1 THEN Q=1
1050 RETURN
1060 '
1070 SCREEN,,1,0             'CLEAN CLOSE
1080 CLS
1090 SCREEN,,0,0
1100 CLS
1110 SYSTEM                  'Close GWBASIC at end.
1120 END
